ST_NumGeometries
Prev | 8.4. Geometry Accessors | Next

## Name

ST_NumGeometries — Returns the number of elements in a geometry collection.

## Synopsis

`integer ST_NumGeometries(`geometry geom`)`;

## Description

Returns the number of Geometries. If geometry is a GEOMETRYCOLLECTION (or MULTI*) return the number of geometries, for single geometries will return 1, otherwise return NULL.

Enhanced: 2.0.0 support for Polyhedral surfaces, Triangles and TIN was introduced.

Changed: 2.0.0 In prior versions this would return NULL if the geometry was not a collection/MULTI type. 2.0.0+ now returns 1 for single geometries e.g POLYGON, LINESTRING, POINT.

This method implements the SQL/MM specification. SQL-MM 3: 9.1.4

This function supports 3d and will not drop the z-index.

This function supports Polyhedral surfaces.

This function supports Triangles and Triangulated Irregular Network Surfaces (TIN).

## Examples

    --Prior versions would have returned NULL for this -- in 2.0.0 this returns 1
    SELECT ST_NumGeometries(ST_GeomFromText('LINESTRING(77.29 29.07,77.42 29.26,77.27 29.31,77.29 29.07)'));
    --result
    1

    --Geometry Collection Example - multis count as one geom in a collection
    SELECT ST_NumGeometries(ST_GeomFromEWKT('GEOMETRYCOLLECTION(MULTIPOINT((-2 3),(-2 2)),
    LINESTRING(5 5 ,10 10),
    POLYGON((-7 4.2,-7.1 5,-7.1 4.3,-7 4.2)))'));
    --result
    3

## See Also

ST_GeometryN, ST_Multi

Prev | Up | Next
ST_NRings | Home | ST_NumInteriorRings